;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; This shooter will generate Magikoopa magic and aim it for Mario.
;; And yes, I retyped it; I personally think mikeyk's/Davros's code formatting looks like crap.
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

!SpriteToGen = $20	; (normal) sprite number to generate
!SpawnSFX = $10		; sound effect to play when shooting it
!SFXBank = $1DF9		; sound effect bank to use for said sound effect
!TotalSpeed = $20		; total speed of the magic when shot (X+Y)
!TimeTillShoot = $60	; how many frames the sprite should wait before firing again

OffsetsLo:			; how much to shift the sprite over, depending on where the player is
db $10,$F0			; left side, right side
OffsetsHi:			;
db $00,$FF			;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; sprite main code wrapper
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

print "INIT ",pc
print "MAIN ",pc
PHB
PHK
PLB
JSR MagicShooterMain
PLB
RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; sprite main code
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ReturnM:
RTS

MagicShooterMain:

LDA $17AB,x		; if it's not time to generate a sprite yet...
BNE ReturnM		; return

LDA #!TimeTillShoot	;
STA $17AB,x		; reset the shoot timer

LDA $178B,x		;
CMP $1C			;
LDA $1793,x		; check the shooter's X position relative to the screen boundary
SBC $1D			;
BNE ReturnM		; if it is offscreen vertically, don't generate anything

LDA $179B,x		;
CMP $1A			;
LDA $17A3,x		; check the shooter's X position relative to the screen boundary
SBC $1B			;
BNE ReturnM		; if it is offscreen horizontally, don't generate anything

LDA $179B,x		;
SEC				;
SBC $1A			;
CLC				;
ADC #$10			;
CMP #$10			; if the sprite is fewer than 10 pixels from either screen boundary...
BCC ReturnM		; don't generate anything

LDA $94			;
;SEC				; carry flag is already set here, since the BCC did not branch
SBC $179B,x		;
CLC				;
ADC #$11			; if the player is too close to the shooter (i.e. within 10 pixels)...
CMP #$22			;
BCC ReturnM		; don't generate anything

JSL $82A9E4		; find a free sprite slot
BMI ReturnM		; return if there are none free

LDA #!SpawnSFX		;
STA !SFXBank		; play the spawning sound effect

LDA #$01			;
STA $14C8,y		; set the sprite status: 01 -> init

LDA #!SpriteToGen	;
STA.w $009E,y		; set the sprite number to generate

PHY				;
JSR SubHorizPosS		;
LDA OffsetsLo,y		;
STA $04			;
LDA OffsetsHi,y		;
STA $05			;
PLY				;

LDA $179B,x		; set the X position of the new sprite:
CLC				;
ADC $04			;
STA.w $00E4,y		; low byte
LDA $17A3,x		;
ADC $05			;
STA $14E0,y		; high byte

LDA $178B,x		; set the Y position of the new sprite:
STA.w $00D8,y		; low byte
LDA $1793,x		;
STA $14D4,y		; high byte

PHX				; preserve the shooter index
TYX				; get the spawned sprite index into X
JSL $87F7D2		; clear all old sprite values and load new ones
PLX				; retrieve the shooter index

LDA #!TotalSpeed		; A = total speed to give the spawned sprite
JSR MagikoopaAiming	; call the aiming routine
LDA $00			; when the subroutine returns...
STA.w $00AA,y		; $00 will have the appropriate Y speed for the sprite,
LDA $01			; and $01 will have the appropriate X speed
STA.w $00B6,y		;

RTS				;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; aiming routine
; input: accumulator should be set to total speed (x+y)
; output: $00 = y speed, $01 = x speed
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MagikoopaAiming:

			STA $01
			PHX					;\ preserve sprite indexes of Magikoopa and magic
			PHY					;/
			JSR CODE_01AD42				; $0E = vertical distance to Mario
			STY $02					; $02 = vertical direction to Mario
			LDA $0E					;\ $0C = vertical distance to Mario, positive
			BPL CODE_01BF7C				; |
			EOR #$FF				; |
			CLC					; |
			ADC #$01				; |
CODE_01BF7C:		STA $0C					;/
			JSR SubHorizPosS			; $0F = horizontal distance to Mario
			STY $03					; $03 = horizontal direction to Mario
			LDA $0F					;\ $0D = horizontal distance to Mario, positive
			BPL CODE_01BF8C				; |
			EOR #$FF				; |
			CLC					; |
			ADC #$01				; |
CODE_01BF8C:		STA $0D					;/
			LDY #$00
			LDA $0D					;\ if vertical distance less than horizontal distance,
			CMP $0C					; |
			BCS CODE_01BF9F				;/ branch
			INY					; set y register
			PHA					;\ switch $0C and $0D
			LDA $0C					; |
			STA $0D					; |
			PLA					; |
			STA $0C					;/
CODE_01BF9F:		LDA #$00				;\ zero out $00 and $0B
			STA $0B					; | ...what's wrong with STZ?
			STA $00					;/
			LDX $01					;\ divide $0C by $0D?
CODE_01BFA7:		LDA $0B					; |\ if $0C + loop counter is less than $0D,
			CLC					; | |
			ADC $0C					; | |
			CMP $0D					; | |
			BCC CODE_01BFB4				; |/ branch
			SBC $0D					; | else, subtract $0D
			INC $00					; | and increase $00
CODE_01BFB4:		STA $0B					; |
			DEX					; |\ if still cycles left to run,
			BNE CODE_01BFA7				;/ / go to start of loop
			TYA					;\ if $0C and $0D was not switched,
			BEQ CODE_01BFC6				;/ branch
			LDA $00					;\ else, switch $00 and $01
			PHA					; |
			LDA $01					; |
			STA $00					; |
			PLA					; |
			STA $01					;/
CODE_01BFC6:		LDA $00					;\ if horizontal distance was inverted,
			LDY $02					; | invert $00
			BEQ CODE_01BFD3				; |
			EOR #$FF				; |
			CLC					; |
			ADC #$01				; |
			STA $00					;/
CODE_01BFD3:		LDA $01					;\ if vertical distance was inverted,
			LDY $03					; | invert $01
			BEQ CODE_01BFE0				; |
			EOR #$FF				; |
			CLC					; |
			ADC #$01				; |
			STA $01					;/
CODE_01BFE0:		PLY					;\ retrieve Magikoopa and magic sprite indexes
			PLX					;/
			RTS					; return
			
			CODE_01AD42:		LDY #$00
			LDA $D3
			CLC
			ADC #$10
			SEC
			SBC $178B,x
			STA $0E
			LDA $D4
			SBC $1793,x
			BPL Return01AD53
			INY
Return01AD53:		RTS

SubHorizPosS:

LDY #$00
LDA $94
SEC
SBC $179B,x
STA $0F
LDA $95
SBC $17A3,x
BPL $01
INY
RTS
